#!/usr/bin/ruby
# coding: ASCII-8BIT

#https://kzn.db.ertelecom.ru/cgi-bin/ppo/excelmps/statistic_user_pppoe.entry
# :    "client$c"
# :   "passwd$c"
#https://kzn.db.ertelecom.ru/cgi-bin/ppo/excelmps/statistic_user_pppoe.statistic_user
# :    "client$c"
# :   "id_session$c"
# 1:    "day1$c"
# 1:   "month1$c"
# 1:     "year1$c"
# 2:    "day2$c"
# 2:   "month2$c"
# 2:     "year2$c"

require 'getoptlong'
require 'net/https'

opts=GetoptLong.new(
  ['-h','--help'            ,GetoptLong::NO_ARGUMENT],
  ['-c','--client'          ,GetoptLong::REQUIRED_ARGUMENT],
  ['-p','--passwd'          ,GetoptLong::REQUIRED_ARGUMENT],
  ['-b','--begin_date'      ,GetoptLong::REQUIRED_ARGUMENT],
  ['-e','--end_date'        ,GetoptLong::REQUIRED_ARGUMENT]
)

client=''
passwd=''
begin_date=''
end_date=''
opts.each do |opt,arg|
  case opt
    when '-h'
      puts <<-EOF
===============================================================================
domra-statistic.rb [OPTIONS]
ver 0.1

-h, --help                    :  
-c, --client            VALUE : 
-p, --passwd            VALUE : 
-b, --begin_date   YYYY-MM-DD :  
-e, --end_date     YYYY-MM-DD :  
===============================================================================
        EOF
      exit
    when '-c'
      client='&client$c='+arg
    when '-p'
      passwd='&passwd$c='+arg
    when '-b'
      begin_date=arg
    when '-e'
      end_date=arg
  end
end

http=Net::HTTP.new('kzn.db.ertelecom.ru',443)
http.use_ssl=true
response=http.post('/cgi-bin/ppo/excelmps/statistic_user_pppoe.entry',
  'new_style$i=1'+client+passwd);
resp_body=response.body
#puts resp_body

unless resp_body.include? '<title>  .ru</title>' then # 
  if resp_body.include? '<title></title>' then
    resp_idx=resp_body.index('<td class="info_win">')+'<td class="info_win">'.length-1
    resp_len=resp_body.length-resp_idx+1
    resp_body=resp_body[resp_idx,resp_len]
    resp_idx=resp_body.index('<input type="button" value=""')-1
    error_message=resp_body[1,resp_idx]
    error_message.gsub!('<br>',"\n")
    puts 'Error'
    puts error_message
  else
    puts 'Unknown Error'
  end
  exit
end

#   
resp_idx=resp_body.index('statistic_user_pppoe.get_date_show_statistic?')+'statistic_user_pppoe.get_date_show_statistic?'.length-1
resp_len=resp_body.length-resp_idx+1
resp_body=resp_body[resp_idx,resp_len]
resp_idx=resp_body.index('">')-1
session=resp_body[1,resp_idx]

#   
require 'parsedate'
include ParseDate
aperiod=parsedate(begin_date,true)
begin_date='&year1$c='+aperiod[0].to_s+'&month1$c='+aperiod[1].to_s+'&day1$c='+aperiod[2].to_s
aperiod=parsedate(end_date,true)
end_date='&year2$c='+aperiod[0].to_s+'&month2$c='+aperiod[1].to_s+'&day2$c='+aperiod[2].to_s

#   
response=http.post('/cgi-bin/ppo/excelmps/statistic_user_pppoe.statistic_user',
  session+begin_date+end_date);
resp_body=response.body
#puts resp_body

#  
resp_idx=resp_body.index('  <br>')+'  <br>'.length-1
resp_len=resp_body.length-resp_idx+1
resp_body=resp_body[resp_idx,resp_len]
resp_idx=resp_body.index('<br>')-1
agreement=resp_body[1,resp_idx]

#  
resp_idx=resp_body.index('<br> ')+'<br> '.length-1
resp_len=resp_body.length-resp_idx+1
resp_body=resp_body[resp_idx,resp_len]
resp_idx=resp_body.index('  .')-1
period=resp_body[1,resp_idx].gsub!('','-')

#  
resp_idx=resp_body.index('  ')+'  '.length-1
resp_len=resp_body.length-resp_idx+1
resp_body=resp_body[resp_idx,resp_len]
resp_idx=resp_body.index(' ')-1
datetime=resp_body[1,resp_idx]

#  
resp_idx=resp_body.index('<font size="+1">')+'<font size="+1">'.length-1
resp_len=resp_body.length-resp_idx+1
resp_body=resp_body[resp_idx,resp_len]
resp_idx=resp_body.index('</font>')-1
balance=resp_body[1,resp_idx]

#   
puts '================================================================================'
puts 'Agreement : '+agreement
puts 'Datetime  : '+datetime
puts 'Balance   : '+balance
puts 'Statistic : '+period
sumtrafmb=0
while resp_body.include? '     ' do
  #   
  resp_idx=resp_body.index('      "')+'      "'.length-1
  resp_len=resp_body.length-resp_idx+1
  resp_body=resp_body[resp_idx,resp_len]
  resp_idx=resp_body.index('"  ')-1
  traf=resp_body[1,resp_idx]
  traf.gsub!(' ','External');
  traf.gsub!('','Media');
  traf.gsub!('','Internal');
  traf.gsub!('  ip','City');
  
  #  
  resp_idx=resp_body.index(': ')+': '.length-1
  resp_len=resp_body.length-resp_idx+1
  resp_body=resp_body[resp_idx,resp_len]
  resp_idx=resp_body.index(' ')-1
  trafmb=resp_body[1,resp_idx]
  trafmb.gsub!(' ','')
  trafmb.gsub!(',','.')
  
  #   
  puts ' '+traf.ljust(9)+': '+sprintf("%8.2f",trafmb.to_f)+'Mb'
  sumtrafmb+=trafmb.to_f
end
puts ' '+'SUM'.ljust(9)+': '+sprintf("%8.2f",sumtrafmb)+'Mb'
puts '================================================================================'

