#!/usr/bin/ruby
# coding: ASCII-8BIT

#https://kzn.db.ertelecom.ru/cgi-bin/ppo/es_webface/pay_through_domru_card.login_fio
#https://kzn.db.ertelecom.ru/cgi-bin/ppo/es_webface/pay_through_domru_card.find_cl
# :  "agreement_number$c"
# :      "family$c"
# :    "street$c"
# :      "house_num$c"
# :   "building_number$c"
# : "office$c"

require 'getoptlong'
require 'net/https'

opts=GetoptLong.new(
  ['-h','--help'            ,GetoptLong::NO_ARGUMENT],
  ['-a','--agreement_number',GetoptLong::REQUIRED_ARGUMENT],
  ['-f','--family'          ,GetoptLong::REQUIRED_ARGUMENT],
  ['-s','--street'          ,GetoptLong::REQUIRED_ARGUMENT],
  ['-n','--house_num'       ,GetoptLong::REQUIRED_ARGUMENT],
  ['-b','--building_number' ,GetoptLong::REQUIRED_ARGUMENT],
  ['-o','--office'          ,GetoptLong::REQUIRED_ARGUMENT]
)

agreement_number=''
family=''
street=''
house_num=''
building_number=''
office=''
opts.each do |opt,arg|
  case opt
    when '-h'
      puts <<-EOF
===============================================================================
domra-balance2.rb [OPTIONS]
ver 0.1

-h, --help                    :  
-a, --agreement_number  VALUE : 
-f, --family            VALUE : 
-s, --street            VALUE : 
-n, --house_num         VALUE : 
-b, --building_number   VALUE : 
-o, --office            VALUE : 
===============================================================================
        EOF
      exit
    when '-a'
      agreement_number='&agreement_number$c='+arg
    when '-f'
      family='&family$c='+arg
    when '-s'
      street='&street$c='+arg
    when '-n'
      house_num='&house_num$c='+arg
    when '-b'
      building_number='&building_number$c='+arg
    when '-o'
      office='&office$c='+arg
  end
end

http=Net::HTTP.new('kzn.db.ertelecom.ru',443)
http.use_ssl=true
response=http.post('/cgi-bin/ppo/es_webface/pay_through_domru_card.find_cl',
  'new_style$i=1'+agreement_number+family+street+house_num+building_number+office);
resp_body=response.body
#puts resp_body

unless resp_body.include? '<TITLE>     - .ru.</TITLE>' then # 
  if resp_body.include? '<title></title>' then
    resp_idx=resp_body.index('<td class="info_win">')+'<td class="info_win">'.length-1
    resp_len=resp_body.length-resp_idx+1
    resp_body=resp_body[resp_idx,resp_len]
    resp_idx=resp_body.index('<input type="button" value=""')-1
    error_message=resp_body[1,resp_idx]
    error_message.gsub!('<br>',"\n")
    puts 'Error'
    puts error_message
  else
    puts 'Unknown Error'
  end
  exit
end

while resp_body.include? 'pay_through_domru_card.get_card_data' do
  #  
  resp_idx=resp_body.index('  ')+'  '.length-1
  resp_len=resp_body.length-resp_idx+1
  resp_body=resp_body[resp_idx,resp_len]
  resp_idx=resp_body.index('</a>')-1
  agreement=resp_body[1,resp_idx]

  #  
  resp_idx=resp_body.index('  ')+'  '.length-1
  resp_len=resp_body.length-resp_idx+1
  resp_body=resp_body[resp_idx,resp_len]
  resp_idx=resp_body.index(' ')-1
  datetime=resp_body[1,resp_idx]

  #  
  resp_idx=resp_body.index('<font size="+1">')+'<font size="+1">'.length-1
  resp_len=resp_body.length-resp_idx+1
  resp_body=resp_body[resp_idx,resp_len]
  resp_idx=resp_body.index('</font>')-1
  balance=resp_body[1,resp_idx]

  #   
  puts '================================================================================'
  puts 'Agreement : '+agreement
  puts 'Datetime  : '+datetime
  puts 'Balance   : '+balance
end
puts '================================================================================'

